(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     35978,       1143]*)
(*NotebookOutlinePosition[     39085,       1249]*)
(*  CellTagsIndexPosition[     38581,       1228]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[{
  StyleBox["Trees",
    FontWeight->"Bold"],
  "\n",
  StyleBox["All Copywrongs  Reversed  -- Cornelius Nevrinceanu,  2005 --  \
Omnia jura vindicabuntur",
    FontSize->5,
    FontWeight->"Plain",
    FontSlant->"Italic",
    FontVariations->{"CompatibilityType"->0}]
}], "Title",
  TextAlignment->Center,
  TextJustification->0,
  FontFamily->"Courier"],

Cell[TextData[{
  "\n",
  StyleBox["You should go to a pear-tree for pears, not to an elm.\n",
    FontFamily->"American Typewriter",
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox["Publilius  Syrus\nMaxim 674",
    FontFamily->"American Typewriter",
    FontSize->10]
}], "SmallText",
  TextAlignment->Right,
  TextJustification->0,
  FontSize->8],

Cell[" 1.  Principle #1", "Section",
  FontFamily->"Courier"],

Cell["  \tEverything  is an expression ", "Text",
  FontFamily->"Courier"],

Cell[" Examples", "Subsection",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(2\)], "Input"],

Cell[BoxData[
    \(2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Pi\)], "Input"],

Cell[BoxData[
    \(\[Pi]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Symbol\)], "Input"],

Cell[BoxData[
    \(Symbol\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \("\<This is a string\>"\)], "Input"],

Cell[BoxData[
    \("This is a string"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plus[x\ , \ Pi]\)], "Input"],

Cell[BoxData[
    \(\[Pi] + x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(QuoteTree[]\  = \ \[IndentingNewLine]{He\ , {{who, \ 
            to\ , {{bed}\ , goes}, \ sober}}, \ {Will, \ fall, {with}, \ 
          the, \ {{leaf, \ of}}, \ October}, \ {John, \ 
          Wilmot, {\ Earl, \ of, \ Rochester}, \ {1647, \ 1680}}}\)], "Input",\

  CellTags->"Rochester"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output",
  CellTags->"Rochester"]
}, Open  ]],

Cell[" 2.  Principle #2", "Section",
  FontFamily->"Courier"],

Cell["\tEach expression  is a tree", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[2]\)], "Input"],

Cell[BoxData[
    InterpretationBox["2",
      TreeForm[ 2],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[Pi]\)], "Input"],

Cell[BoxData[
    InterpretationBox["\[Pi]",
      TreeForm[ Pi],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[Symbol]\)], "Input"],

Cell[BoxData[
    InterpretationBox["Symbol",
      TreeForm[ Symbol],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[Plus[x, \ Pi]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("Plus"[\[Pi], x]\),
      TreeForm[ 
        Plus[ Pi, x]],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"List\"\>", "[", 
        RowBox[{"He", ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", GridBox[{
                        {"\<\"|\"\>"},
                        {
                          RowBox[{"\<\"List\"\>", "[", 
                            RowBox[{"who", ",", "to", ",", GridBox[{
                                  {"\<\"|\"\>"},
                                  {
                                    RowBox[{"\<\"List\"\>", "[", 
                                      RowBox[{GridBox[{
                                        {"\<\"|\"\>"},
                                        {\("List"[bed]\)}
                                        },
                                        GridBaseline->{Baseline, {1, 1}},
                                        ColumnAlignments->{Left}], ",", 
                                        "goes"}], "]"}]}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], ",", "sober"}], 
                            "]"}]}
                        },
                      GridBaseline->{Baseline, {1, 1}},
                      ColumnAlignments->{Left}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ 
                ColumnForm[ {"|", 
                  "List"[ who, to, 
                    ColumnForm[ {"|", 
                      "List"[ 
                        ColumnForm[ {"|", 
                          "List"[ bed]}], goes]}], sober]}]]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{"Will", ",", "fall", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[with]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "the", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {
                            RowBox[{"\<\"List\"\>", "[", GridBox[{
                                  {"\<\"|\"\>"},
                                  {\("List"[leaf, of]\)}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], "]"}]}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "October"}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ Will, fall, 
                ColumnForm[ {"|", 
                  "List"[ with]}], the, 
                ColumnForm[ {"|", 
                  "List"[ 
                    ColumnForm[ {"|", 
                      "List"[ leaf, of]}]]}], October]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{"John", ",", "Wilmot", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[Earl, of, Rochester]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[1647, 1680]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}]}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ John, Wilmot, 
                ColumnForm[ {"|", 
                  "List"[ Earl, of, Rochester]}], 
                ColumnForm[ {"|", 
                  "List"[ 1647, 1680]}]]}],
            Editable->False]}], "]"}],
      TreeForm[ {He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, Wilmot, {Earl, of, Rochester}, {
        1647, 1680}}}],
      Editable->False]], "Output"]
}, Open  ]],

Cell[" 3.  Principle #3", "Section",
  FontFamily->"Courier"],

Cell["\<\
\tEach expression , as a tree, can be disassembled , modified, \
reassembled.\
\>", "Text",
  FontFamily->"Courier"],

Cell[" 3.1 Depth-first disassembly and collection", "Subsection",
  FontFamily->"Courier"],

Cell[BoxData[
    \(\(LeafQ[s_Symbol\  | \ n_?NumberQ\  | \ st_String\ ]\  = \ 
        True;\)\)], "Input",
  CellTags->"LeafQ"],

Cell[BoxData[
    \(\(LeafQ[_]\  = \ False;\)\)], "Input"],

Cell[TextData[StyleBox["Examples",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \({LeafQ[2], \ LeafQ[Pi], \ LeafQ[Symbol], \ LeafQ["\<String\>"], \ 
      LeafQ[2\  + \ Pi], \ LeafQ[Quote[]]}\)], "Input"],

Cell[BoxData[
    \({True, True, True, True, False, False}\)], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["Depth-first traversal and collection of leaves",
  FontSize->16]], "Subsubsection",
  CellMargins->{{29, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier",
  FontSize->9],

Cell[BoxData[
    \(DFirst[l_?LeafQ]\  := \ {l}\)], "Input",
  CellTags->"DFirst"],

Cell[BoxData[
    \(DFirst[head_[tailSeq___]]\  := \ 
      Join[DFirst[head], \ DFirstSeq[{tailSeq}]]\)], "Input"],

Cell[BoxData[
    \(\(DFirstSeq[{}]\  = \ {};\)\)], "Input",
  CellTags->"DFirstSeq"],

Cell[BoxData[
    \(DFirstSeq[{first_, \ rest___}]\  := \ 
      Join[DFirst[first], \ DFirstSeq[{rest}]]\)], "Input"],

Cell[TextData[StyleBox["Example",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirst[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({List, He, List, List, who, to, List, List, bed, goes, sober, List, 
      Will, fall, List, with, the, List, List, leaf, of, October, List, John, 
      Wilmot, List, Earl, of, Rochester, List, 1647, 1680}\)], "Output"]
}, Open  ]],

Cell[" 3.2 Depth-first disassembly and reverse collection", "Subsection",
  FontFamily->"Courier"],

Cell[BoxData[
    \(\(LeafQ[s_Symbol\  | \ n_?NumberQ\  | \ st_String\ ]\  = \ 
        True;\)\)], "Input"],

Cell[BoxData[
    \(\(LeafQ[_]\  = \ False;\)\)], "Input"],

Cell[TextData[StyleBox["Examples",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \({LeafQ[2], \ LeafQ[Pi], \ LeafQ[Symbol], \ LeafQ["\<String\>"], \ 
      LeafQ[2\  + \ Pi], \ LeafQ[Quote[]]}\)], "Input"],

Cell[BoxData[
    \({True, True, True, True, False, False}\)], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["Depth-first traversal and collection of leafs",
  FontSize->16]], "Subsubsection",
  CellMargins->{{29, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[BoxData[
    \(DFirstS[l_?LeafQ]\  := \ {l}\)], "Input",
  CellTags->"DFirstS"],

Cell[BoxData[
    \(DFirstS[head_[tailSeq___]]\  := \ 
      Join[DFirstSeqS[{tailSeq}], \ DFirstS[head]]\)], "Input"],

Cell[BoxData[
    \(\(DFirstSeqS[{}]\  = \ {};\)\)], "Input",
  CellTags->"DFirstSeqS"],

Cell[BoxData[
    \(DFirstSeqS[{first_, \ rest___}]\  := \ 
      Join[DFirstSeqS[{rest}], \ DFirstS[first]]\)], "Input"],

Cell[TextData[StyleBox["Example",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstS[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({1680, 1647, List, Rochester, of, Earl, List, Wilmot, John, List, 
      October, of, leaf, List, List, the, with, List, fall, Will, List, 
      sober, goes, bed, List, List, to, who, List, List, He, 
      List}\)], "Output"]
}, Open  ]],

Cell[" 3.3 Depth-first disassembly and re-assembly", "Subsection",
  FontFamily->"Courier"],

Cell[TextData[StyleBox["Note: \nTree will be regenerated  to the original \
shape.You will not be able to tell from the output alone that the tree has \
been,indeed,completely disassembled,before it was put back together. Just \
trust me for now; next example will persuade you.\n",
  FontSlant->"Italic"]], "Text",
  CellMargins->{{28.5, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[BoxData[
    \(\(LeafQ[s_Symbol\  | \ n_?NumberQ\  | \ st_String\ ]\  = \ 
        True;\)\)], "Input"],

Cell[BoxData[
    \(\(LeafQ[_]\  = \ False;\)\)], "Input"],

Cell[TextData[StyleBox["Depth-first traversal and reverse collection of \
leaves",
  FontSize->16]], "Subsubsection",
  CellMargins->{{29, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[BoxData[
    \(DFirstA[l_?LeafQ]\  := \ l\)], "Input",
  CellTags->"DFirstA"],

Cell[BoxData[
    \(DFirstA[head_[tailSeq___]]\  := \ 
      Apply[DFirstA[head], \ \ DFirstSeqA[{tailSeq}]]\)], "Input"],

Cell[BoxData[
    \(\(DFirstSeqA[{}]\  = \ {};\)\)], "Input",
  CellTags->"DFirstSeqA"],

Cell[BoxData[
    \(DFirstSeqA[{first_, \ rest___}]\  := \ 
      Prepend[DFirstSeqA[{rest}], \ \ \ DFirstA[first]]\)], "Input"],

Cell[TextData[StyleBox["Example",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstA[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[DFirstA[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"List\"\>", "[", 
        RowBox[{"He", ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", GridBox[{
                        {"\<\"|\"\>"},
                        {
                          RowBox[{"\<\"List\"\>", "[", 
                            RowBox[{"who", ",", "to", ",", GridBox[{
                                  {"\<\"|\"\>"},
                                  {
                                    RowBox[{"\<\"List\"\>", "[", 
                                      RowBox[{GridBox[{
                                        {"\<\"|\"\>"},
                                        {\("List"[bed]\)}
                                        },
                                        GridBaseline->{Baseline, {1, 1}},
                                        ColumnAlignments->{Left}], ",", 
                                        "goes"}], "]"}]}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], ",", "sober"}], 
                            "]"}]}
                        },
                      GridBaseline->{Baseline, {1, 1}},
                      ColumnAlignments->{Left}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ 
                ColumnForm[ {"|", 
                  "List"[ who, to, 
                    ColumnForm[ {"|", 
                      "List"[ 
                        ColumnForm[ {"|", 
                          "List"[ bed]}], goes]}], sober]}]]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{"Will", ",", "fall", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[with]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "the", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {
                            RowBox[{"\<\"List\"\>", "[", GridBox[{
                                  {"\<\"|\"\>"},
                                  {\("List"[leaf, of]\)}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], "]"}]}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "October"}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ Will, fall, 
                ColumnForm[ {"|", 
                  "List"[ with]}], the, 
                ColumnForm[ {"|", 
                  "List"[ 
                    ColumnForm[ {"|", 
                      "List"[ leaf, of]}]]}], October]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{"John", ",", "Wilmot", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[Earl, of, Rochester]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[1647, 1680]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}]}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ John, Wilmot, 
                ColumnForm[ {"|", 
                  "List"[ Earl, of, Rochester]}], 
                ColumnForm[ {"|", 
                  "List"[ 1647, 1680]}]]}],
            Editable->False]}], "]"}],
      TreeForm[ {He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, Wilmot, {Earl, of, Rochester}, {
        1647, 1680}}}],
      Editable->False]], "Output"]
}, Open  ]],

Cell["3.4: Depth-first disassembly and symmetric re-assembly", "Subsection",
  FontFamily->"Courier"],

Cell[TextData[StyleBox["Note: \n  This will persuade you that something IS \
being done.\n  ",
  FontSlant->"Italic"]], "Text",
  CellMargins->{{28.5, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[BoxData[
    \(\(LeafQ[s_Symbol\  | \ n_?NumberQ\  | \ st_String\ ]\  = \ 
        True;\)\)], "Input"],

Cell[BoxData[
    \(\(LeafQ[_]\  = \ False;\)\)], "Input"],

Cell[TextData[StyleBox["Depth-first traversal and reverse collection of \
leaves",
  FontSize->16]], "Subsubsection",
  CellMargins->{{29, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[BoxData[
    \(DFirstAS[l_?LeafQ]\  := \ l\)], "Input",
  CellTags->"DFirstAS"],

Cell[BoxData[
    \(DFirstAS[head_[tailSeq___]]\  := \ 
      Apply[DFirstAS[head], \ \ DFirstSeqAS[{tailSeq}]]\)], "Input"],

Cell[BoxData[
    \(\(DFirstSeqAS[{}]\  = \ {};\)\)], "Input",
  CellTags->"DFirstSeqAS"],

Cell[BoxData[
    \(DFirstSeqAS[{first_, \ rest___}]\  := \ 
      Append[DFirstSeqAS[{rest}], \ \ \ DFirstAS[first]]\)], "Input"],

Cell[TextData[StyleBox["Example",
  FontSize->16]], "Subsubsection",
  CellMargins->{{35, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstAS[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({{{1680, 1647}, {Rochester, of, Earl}, Wilmot, 
        John}, {October, {{of, leaf}}, the, {with}, fall, 
        Will}, {{sober, {goes, {bed}}, to, who}}, He}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TreeForm[DFirstAS[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"List\"\>", "[", 
        RowBox[{
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[1680, 1647]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[Rochester, of, Earl]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "Wilmot", ",", 
                      "John"}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ 
                ColumnForm[ {"|", 
                  "List"[ 1680, 1647]}], 
                ColumnForm[ {"|", 
                  "List"[ Rochester, of, Earl]}], Wilmot, John]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", 
                    RowBox[{"October", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {
                            RowBox[{"\<\"List\"\>", "[", GridBox[{
                                  {"\<\"|\"\>"},
                                  {\("List"[of, leaf]\)}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], "]"}]}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "the", ",", GridBox[{
                          {"\<\"|\"\>"},
                          {\("List"[with]\)}
                          },
                        GridBaseline->{Baseline, {1, 1}},
                        ColumnAlignments->{Left}], ",", "fall", ",", "Will"}],
                     "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ October, 
                ColumnForm[ {"|", 
                  "List"[ 
                    ColumnForm[ {"|", 
                      "List"[ of, leaf]}]]}], the, 
                ColumnForm[ {"|", 
                  "List"[ with]}], fall, Will]}],
            Editable->False], ",", 
          InterpretationBox[GridBox[{
                {"\<\"|\"\>"},
                {
                  RowBox[{"\<\"List\"\>", "[", GridBox[{
                        {"\<\"|\"\>"},
                        {
                          RowBox[{"\<\"List\"\>", "[", 
                            RowBox[{"sober", ",", GridBox[{
                                  {"\<\"|\"\>"},
                                  {
                                    RowBox[{"\<\"List\"\>", "[", 
                                      RowBox[{"goes", ",", GridBox[{
                                        {"\<\"|\"\>"},
                                        {\("List"[bed]\)}
                                        },
                                        GridBaseline->{Baseline, {1, 1}},
                                        ColumnAlignments->{Left}]}], "]"}]}
                                  },
                                GridBaseline->{Baseline, {1, 1}},
                                ColumnAlignments->{Left}], ",", "to", ",", 
                              "who"}], "]"}]}
                        },
                      GridBaseline->{Baseline, {1, 1}},
                      ColumnAlignments->{Left}], "]"}]}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnAlignments->{Left}],
            ColumnForm[ {"|", 
              "List"[ 
                ColumnForm[ {"|", 
                  "List"[ sober, 
                    ColumnForm[ {"|", 
                      "List"[ goes, 
                        ColumnForm[ {"|", 
                          "List"[ bed]}]]}], to, who]}]]}],
            Editable->False], ",", "He"}], "]"}],
      TreeForm[ {{{1680, 1647}, {Rochester, of, Earl}, Wilmot, John}, {
        October, {{of, leaf}}, the, {with}, fall, Will}, {{sober, {goes, {
        bed}}, to, who}}, He}],
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  "4. Algebra of Assembly and Disassembly \n\t\t\t\t\t\t-- For ",
  StyleBox["Mathematica(",
    FontSlant->"Italic"],
  "l) Entertainment"
}], "Subsection",
  FontFamily->"Courier"],

Cell[TextData[{
  StyleBox[" ",
    FontSize->14],
  StyleBox["4.1 Reverse a list (an auxiliary tool)",
    FontSize->16]
}], "Subsubsection",
  FontFamily->"Courier"],

Cell[BoxData[
    \(\(RevList[{}]\  = \ {};\)\)], "Input",
  CellTags->"RevList"],

Cell[BoxData[
    \(RevList[{first_, \ rest___}\ ]\  := \ 
      Append[RevList[{rest}], \ first]\)], "Input"],

Cell[TextData[{
  StyleBox[" ",
    FontSize->14],
  StyleBox["Example",
    FontSize->16]
}], "Subsubsection",
  CellMargins->{{53.5, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(RevList[{1, \ 2, \ 3}]\)], "Input",
  CellMargins->{{53.5, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({3, 2, 1}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " ",
  StyleBox["4.2 Equations",
    FontSize->16]
}], "Subsubsection",
  FontFamily->"Courier"],

Cell[" A. Data", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirst[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({List, He, List, List, who, to, List, List, bed, goes, sober, List, 
      Will, fall, List, with, the, List, List, leaf, of, October, List, John, 
      Wilmot, List, Earl, of, Rochester, List, 1647, 1680}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstS[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({1680, 1647, List, Rochester, of, Earl, List, Wilmot, John, List, 
      October, of, leaf, List, List, the, with, List, fall, Will, List, 
      sober, goes, bed, List, List, to, who, List, List, He, 
      List}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstS[DFirstS[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    \({List, He, List, List, who, to, List, List, bed, goes, sober, List, 
      Will, fall, List, with, the, List, List, leaf, of, October, List, John, 
      Wilmot, List, Earl, of, Rochester, List, 1647, 1680, List}\)], "Output"]
}, Open  ]],

Cell["  Equations", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirst[QuoteTree[]]\ \  === \ RevList[DFirstS[QuoteTree[]]]\)], "Input",\

  CellMargins->{{39, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
 Dot Product Entertainment
\
\>", "Subsection",
  CellMargins->{{72.5, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier",
  FontSize->18],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirst[QuoteTree[]]\  . \ RevList[DFirstS[QuoteTree[]]]\)], "Input",
  CellMargins->{{72.5, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \(5535009 + bed\^2 + Earl\^2 + fall\^2 + goes\^2 + He\^2 + John\^2 + 
      leaf\^2 + 12\ List\^2 + October\^2 + 2\ of\^2 + Rochester\^2 + 
      sober\^2 + the\^2 + to\^2 + who\^2 + Will\^2 + Wilmot\^2 + 
      with\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Inner[Times, \ 
      DFirst[QuoteTree[]], \ \ RevList[DFirstS[QuoteTree[]]], \ 
      Plus]\)], "Input",
  CellMargins->{{72.5, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \(5535009 + bed\^2 + Earl\^2 + fall\^2 + goes\^2 + He\^2 + John\^2 + 
      leaf\^2 + 12\ List\^2 + October\^2 + 2\ of\^2 + Rochester\^2 + 
      sober\^2 + the\^2 + to\^2 + who\^2 + Will\^2 + Wilmot\^2 + 
      with\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirst[QuoteTree[]]\  . \ DFirstS[QuoteTree[]]\)], "Input",
  CellMargins->{{72.5, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \(3294\ He + 2\ bed\ John + 3360\ List + 2\ fall\ List + 2\ goes\ List + 
      6\ List\^2 + 2\ List\ of + 2\ List\ Rochester + 2\ October\ sober + 
      2\ Earl\ to + 2\ of\ who + 2\ leaf\ Will + 2\ List\ Wilmot + 
      2\ the\ with\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Inner[ScrewUp, \ 
      DFirst[QuoteTree[]], \ \ RevList[DFirstS[QuoteTree[]]], \ 
      Plus]\)], "Input",
  CellMargins->{{72.5, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \("1647*7461" + "1680*0861" + "bed*deb" + "Earl*lraE" + "fall*llaf" + 
      "goes*seog" + "He*eH" + "John*nhoJ" + "leaf*fael" + 12\ "List*tsiL" + 
      "October*rebotcO" + 2\ "of*fo" + "Rochester*retsehcoR" + 
      "sober*rebos" + "the*eht" + "to*ot" + "who*ohw" + "Will*lliW" + 
      "Wilmot*tomliW" + "with*htiw"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(ScrewUp[s1_?LeafQ, \ s2_?LeafQ]\  := \[IndentingNewLine]\ 
      StringJoin[
        ToString[
          s1], \ "\<*\>", \ \[IndentingNewLine]\t\t\ \ \ \ \ StringJoin[
          Reverse[Characters[ToString[s2]]]]]\)], "Input",
  CellMargins->{{168.5, Inherited}, {Inherited, Inherited}},
  CellTags->"ScrewUp"],

Cell[BoxData[""], "Input"],

Cell[" B. Data", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(QuoteTree[]\)], "Input"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstA[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output"]
}, Open  ]],

Cell["  Equation", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(QuoteTree[]\  === \ DFirstA[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[" C. Data", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(QuoteTree[]\)], "Input"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstAS[QuoteTree[]]\)], "Input"],

Cell[BoxData[
    \({{{1680, 1647}, {Rochester, of, Earl}, Wilmot, 
        John}, {October, {{of, leaf}}, the, {with}, fall, 
        Will}, {{sober, {goes, {bed}}, to, who}}, He}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstAS[DFirstAS[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    \({He, {{who, to, {{bed}, goes}, sober}}, {Will, fall, {with}, 
        the, {{leaf, of}}, October}, {John, 
        Wilmot, {Earl, of, Rochester}, {1647, 1680}}}\)], "Output"]
}, Open  ]],

Cell["  Equations", "Text",
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(QuoteTree[]\  === \ DFirstAS[DFirstAS[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstA[QuoteTree[]]\  === \ DFirstAS[DFirstAS[QuoteTree[]]]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " ",
  StyleBox["Finis coronat opus (ripensius faber dixit)",
    FontSize->10]
}], "Text",
  CellMargins->{{104, Inherited}, {Inherited, Inherited}},
  TextAlignment->Right,
  TextJustification->0,
  FontFamily->"Courier"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DFirstAS[{\ \ \ \ {Of, \ Mans, \ first\ , disobedience, and, \ the, \ 
          fruit}, \n\t\t\t{Of, \ that, \ forbidden, \ tree, \ whose, \ 
          mortal, \ taste}, \n\t\t\t{Brought\ , death\ , into, \ the, \ 
          world, and\ , all, \ our, \ 
          woe}\ , \[IndentingNewLine]\t\t\t{John\ , 
          Milton}, \n\t\t\t\ \ \ \ {Paradise\ Lost, \ Book\ i, \ 
          Line\ 1}\ \ \ \ \ }]\)], "Input",
  CellMargins->{{104, Inherited}, {Inherited, Inherited}},
  CellTags->"Milton"],

Cell[BoxData[
    \({{Line, Book\ i, Lost\ Paradise}, {Milton, John}, {woe, our, all, and, 
        world, the, into, death, Brought}, {taste, mortal, whose, tree, 
        forbidden, that, Of}, {fruit, the, and, disobedience, first, Mans, 
        Of}}\)], "Output",
  CellTags->"Milton"]
}, Open  ]],

Cell[TextData[{
  StyleBox["Of Man's first disobedience,and  the fruit\nOf that forbidden \
tree whose mortal taste\nBrought death into the world,and all our woe.",
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox["\n",
    FontSize->9,
    FontWeight->"Bold"],
  StyleBox["John Milton\nParadise Lost, Book i, Line 1",
    FontSize->9]
}], "Text",
  CellMargins->{{290, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontFamily->"American Typewriter"],

Cell["\<\
 ... and remember, this was all about expressions built-up as trees\
\
\>", "Subsection",
  FontFamily->"Courier",
  CellTags->"Trees"],

Cell[" Latinae canemus", "Subsubsection",
  CellMargins->{{410, Inherited}, {Inherited, Inherited}},
  TextAlignment->Right,
  TextJustification->0,
  FontFamily->"Courier",
  FontSize->9],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(DFirstAS[{\ \ \ {Mille, \ mille, \ 
            mille, \ \ decolavimus}, \n\t\t\t{Unus, \ \ homo, \ mille, 
            decolavimus}, \n\t\t\t{Tanto, \ bibit, \ nemo, \ 
            vinis}\ , \[IndentingNewLine]\t\t\ \ \ \ \ {Quanto, \ fudit\ , 
            sanguinis}}]\),
      FontSize->16]], "Input",
  CellMargins->{{104, Inherited}, {Inherited, Inherited}},
  TextAlignment->Right,
  TextJustification->0,
  FontSize->8,
  CellTags->"Aurelianus"],

Cell[BoxData[
    \({{sanguinis, fudit, Quanto}, {vinis, nemo, bibit, Tanto}, {decolavimus, 
        mille, homo, Unus}, {decolavimus, mille, mille, Mille}}\)], "Output",
  CellTags->"Aurelianus"]
}, Open  ]],

Cell[TextData[StyleBox["Rochester...1\nLeafQ...3\nDFirst...3\nDFirstSeq...3\n\
DFirstS...4\nDFirstSeqS...4\nDFirstA...4\nDFirstSeqA...4\nDFirstAS...5\n\
DFirstSeqAS...5\nRevList...6\nScrewUp...7\nMilton...9\nTrees...9\n\
Aurelianus...9\nIndex...9",
  FontFamily->"Courier",
  FontSize->10,
  FontWeight->"Bold"]], "LI",
  CellMargins->{{57.625, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier",
  CellTags->"Index"]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{0, 1020}, {0, 746}},
WindowToolbars->{"RulerBar", "EditBar"},
CellGrouping->Manual,
WindowSize->{910, 719},
WindowMargins->{{4, Automatic}, {Automatic, 1}},
PrintingOptions->{"PrintingMargins"->{{54, 54}, {72, 72}},
"PrintCellBrackets"->True,
"PrintRegistrationMarks"->True,
"PrintMultipleHorizontalPages"->False},
IndexCreationOptions->{"Format"->"Text"},
ShowCellLabel->False,
CellLabelAutoDelete->True,
ShowCellTags->True,
Magnification->1.5,
StyleDefinitions -> "TutorialBook.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Rochester"->{
    Cell[3328, 136, 310, 6, 156, "Input",
      CellTags->"Rochester"],
    Cell[3641, 144, 219, 4, 111, "Output",
      CellTags->"Rochester"]},
  "LeafQ"->{
    Cell[9734, 324, 129, 3, 63, "Input",
      CellTags->"LeafQ"]},
  "DFirst"->{
    Cell[10544, 353, 82, 2, 63, "Input",
      CellTags->"DFirst"]},
  "DFirstSeq"->{
    Cell[10747, 361, 85, 2, 63, "Input",
      CellTags->"DFirstSeq"]},
  "DFirstS"->{
    Cell[12316, 415, 84, 2, 63, "Input",
      CellTags->"DFirstS"]},
  "DFirstSeqS"->{
    Cell[12524, 423, 87, 2, 63, "Input",
      CellTags->"DFirstSeqS"]},
  "DFirstA"->{
    Cell[14104, 472, 82, 2, 63, "Input",
      CellTags->"DFirstA"]},
  "DFirstSeqA"->{
    Cell[14313, 480, 87, 2, 63, "Input",
      CellTags->"DFirstSeqA"]},
  "DFirstAS"->{
    Cell[20329, 636, 84, 2, 63, "Input",
      CellTags->"DFirstAS"]},
  "DFirstSeqAS"->{
    Cell[20543, 644, 89, 2, 63, "Input",
      CellTags->"DFirstSeqAS"]},
  "RevList"->{
    Cell[26247, 795, 81, 2, 63, "Input",
      CellTags->"RevList"]},
  "ScrewUp"->{
    Cell[30414, 945, 330, 7, 156, "Input",
      CellTags->"ScrewUp"]},
  "Milton"->{
    Cell[33168, 1062, 518, 9, 311, "Input",
      CellTags->"Milton"],
    Cell[33689, 1073, 289, 5, 137, "Output",
      CellTags->"Milton"]},
  "Trees"->{
    Cell[34491, 1097, 145, 5, 111, "Subsection",
      CellTags->"Trees"]},
  "Aurelianus"->{
    Cell[34852, 1113, 481, 11, 156, "Input",
      CellTags->"Aurelianus"],
    Cell[35336, 1126, 196, 3, 111, "Output",
      CellTags->"Aurelianus"]},
  "Index"->{
    Cell[35547, 1132, 427, 9, 303, "LI",
      CellTags->"Index"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Rochester", 36954, 1170},
  {"LeafQ", 37113, 1175},
  {"DFirst", 37195, 1178},
  {"DFirstSeq", 37281, 1181},
  {"DFirstS", 37368, 1184},
  {"DFirstSeqS", 37456, 1187},
  {"DFirstA", 37544, 1190},
  {"DFirstSeqA", 37632, 1193},
  {"DFirstAS", 37721, 1196},
  {"DFirstSeqAS", 37811, 1199},
  {"RevList", 37900, 1202},
  {"ScrewUp", 37985, 1205},
  {"Milton", 38071, 1208},
  {"Trees", 38228, 1213},
  {"Aurelianus", 38322, 1216},
  {"Index", 38488, 1221}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 371, 13, 129, "Title"],
Cell[2128, 66, 355, 12, 114, "SmallText"],
Cell[2486, 80, 61, 1, 132, "Section"],
Cell[2550, 83, 74, 1, 39, "Text"],
Cell[2627, 86, 56, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[2708, 91, 34, 1, 44, "Input"],
Cell[2745, 94, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2817, 100, 35, 1, 44, "Input"],
Cell[2855, 103, 39, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2931, 109, 39, 1, 44, "Input"],
Cell[2973, 112, 40, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3050, 118, 55, 1, 44, "Input"],
Cell[3108, 121, 52, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3197, 127, 48, 1, 44, "Input"],
Cell[3248, 130, 43, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3328, 136, 310, 6, 156, "Input",
  CellTags->"Rochester"],
Cell[3641, 144, 219, 4, 111, "Output",
  CellTags->"Rochester"]
}, Open  ]],
Cell[3875, 151, 61, 1, 132, "Section"],
Cell[3939, 154, 69, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[4033, 159, 44, 1, 44, "Input"],
Cell[4080, 162, 95, 3, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4212, 170, 45, 1, 44, "Input"],
Cell[4260, 173, 100, 3, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4397, 181, 49, 1, 44, "Input"],
Cell[4449, 184, 105, 3, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4591, 192, 56, 1, 44, "Input"],
Cell[4650, 195, 132, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4819, 204, 54, 1, 44, "Input"],
Cell[4876, 207, 4557, 102, 214, "Output"]
}, Open  ]],
Cell[9448, 312, 61, 1, 132, "Section"],
Cell[9512, 315, 126, 4, 66, "Text"],
Cell[9641, 321, 90, 1, 61, "Subsection"],
Cell[9734, 324, 129, 3, 63, "Input",
  CellTags->"LeafQ"],
Cell[9866, 329, 58, 1, 44, "Input"],
Cell[9927, 332, 152, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[10104, 339, 142, 2, 75, "Input"],
Cell[10249, 343, 72, 1, 40, "Output"]
}, Open  ]],
Cell[10336, 347, 205, 4, 57, "Subsubsection"],
Cell[10544, 353, 82, 2, 63, "Input",
  CellTags->"DFirst"],
Cell[10629, 357, 115, 2, 75, "Input"],
Cell[10747, 361, 85, 2, 63, "Input",
  CellTags->"DFirstSeq"],
Cell[10835, 365, 118, 2, 75, "Input"],
Cell[10956, 369, 151, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[11132, 376, 52, 1, 44, "Input"],
Cell[11187, 379, 240, 3, 118, "Output"]
}, Open  ]],
Cell[11442, 385, 98, 1, 61, "Subsection"],
Cell[11543, 388, 108, 2, 44, "Input"],
Cell[11654, 392, 58, 1, 44, "Input"],
Cell[11715, 395, 152, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[11892, 402, 142, 2, 75, "Input"],
Cell[12037, 406, 72, 1, 40, "Output"]
}, Open  ]],
Cell[12124, 410, 189, 3, 57, "Subsubsection"],
Cell[12316, 415, 84, 2, 63, "Input",
  CellTags->"DFirstS"],
Cell[12403, 419, 118, 2, 75, "Input"],
Cell[12524, 423, 87, 2, 63, "Input",
  CellTags->"DFirstSeqS"],
Cell[12614, 427, 121, 2, 75, "Input"],
Cell[12738, 431, 151, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[12914, 438, 53, 1, 44, "Input"],
Cell[12970, 441, 247, 4, 118, "Output"]
}, Open  ]],
Cell[13232, 448, 91, 1, 61, "Subsection"],
Cell[13326, 451, 400, 6, 198, "Text"],
Cell[13729, 459, 108, 2, 44, "Input"],
Cell[13840, 463, 58, 1, 44, "Input"],
Cell[13901, 466, 200, 4, 57, "Subsubsection"],
Cell[14104, 472, 82, 2, 63, "Input",
  CellTags->"DFirstA"],
Cell[14189, 476, 121, 2, 75, "Input"],
Cell[14313, 480, 87, 2, 63, "Input",
  CellTags->"DFirstSeqA"],
Cell[14403, 484, 128, 2, 75, "Input"],
Cell[14534, 488, 151, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[14710, 495, 53, 1, 44, "Input"],
Cell[14766, 498, 194, 3, 92, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14997, 506, 63, 1, 44, "Input"],
Cell[15063, 509, 4557, 102, 214, "Output"]
}, Open  ]],
Cell[19635, 614, 101, 1, 61, "Subsection"],
Cell[19739, 617, 212, 4, 117, "Text"],
Cell[19954, 623, 108, 2, 44, "Input"],
Cell[20065, 627, 58, 1, 44, "Input"],
Cell[20126, 630, 200, 4, 57, "Subsubsection"],
Cell[20329, 636, 84, 2, 63, "Input",
  CellTags->"DFirstAS"],
Cell[20416, 640, 124, 2, 75, "Input"],
Cell[20543, 644, 89, 2, 63, "Input",
  CellTags->"DFirstSeqAS"],
Cell[20635, 648, 130, 2, 75, "Input"],
Cell[20768, 652, 151, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[20944, 659, 54, 1, 44, "Input"],
Cell[21001, 662, 194, 3, 92, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21232, 670, 64, 1, 44, "Input"],
Cell[21299, 673, 4562, 103, 312, "Output"]
}, Open  ]],
Cell[25876, 779, 198, 6, 92, "Subsection"],
Cell[26077, 787, 167, 6, 57, "Subsubsection"],
Cell[26247, 795, 81, 2, 63, "Input",
  CellTags->"RevList"],
Cell[26331, 799, 110, 2, 75, "Input"],
Cell[26444, 803, 196, 7, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[26665, 814, 115, 2, 44, "Input"],
Cell[26783, 818, 43, 1, 40, "Output"]
}, Open  ]],
Cell[26841, 822, 114, 5, 57, "Subsubsection"],
Cell[26958, 829, 49, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[27032, 834, 52, 1, 44, "Input"],
Cell[27087, 837, 240, 3, 118, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27364, 845, 53, 1, 44, "Input"],
Cell[27420, 848, 247, 4, 118, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27704, 857, 62, 1, 44, "Input"],
Cell[27769, 860, 246, 3, 118, "Output"]
}, Open  ]],
Cell[28030, 866, 52, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[28107, 871, 152, 3, 44, "Input"],
Cell[28262, 876, 38, 1, 40, "Output"]
}, Open  ]],
Cell[28315, 880, 158, 6, 100, "Subsection"],

Cell[CellGroupData[{
Cell[28498, 890, 148, 2, 44, "Input"],
Cell[28649, 894, 251, 4, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28937, 903, 185, 4, 75, "Input"],
Cell[29125, 909, 251, 4, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29413, 918, 139, 2, 44, "Input"],
Cell[29555, 922, 267, 4, 93, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29859, 931, 187, 4, 75, "Input"],
Cell[30049, 937, 350, 5, 118, "Output"]
}, Open  ]],
Cell[30414, 945, 330, 7, 156, "Input",
  CellTags->"ScrewUp"],
Cell[30747, 954, 26, 0, 44, "Input"],
Cell[30776, 956, 49, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[30850, 961, 44, 1, 44, "Input"],
Cell[30897, 964, 194, 3, 92, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31128, 972, 53, 1, 44, "Input"],
Cell[31184, 975, 194, 3, 92, "Output"]
}, Open  ]],
Cell[31393, 981, 51, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[31469, 986, 73, 1, 44, "Input"],
Cell[31545, 989, 38, 1, 40, "Output"]
}, Open  ]],
Cell[31598, 993, 49, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[31672, 998, 44, 1, 44, "Input"],
Cell[31719, 1001, 194, 3, 92, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31950, 1009, 54, 1, 44, "Input"],
Cell[32007, 1012, 194, 3, 92, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32238, 1020, 64, 1, 44, "Input"],
Cell[32305, 1023, 194, 3, 92, "Output"]
}, Open  ]],
Cell[32514, 1029, 52, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[32591, 1034, 84, 1, 44, "Input"],
Cell[32678, 1037, 38, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32753, 1043, 93, 1, 75, "Input"],
Cell[32849, 1046, 38, 1, 40, "Output"]
}, Open  ]],
Cell[32902, 1050, 241, 8, 39, "Text"],

Cell[CellGroupData[{
Cell[33168, 1062, 518, 9, 311, "Input",
  CellTags->"Milton"],
Cell[33689, 1073, 289, 5, 137, "Output",
  CellTags->"Milton"]
}, Open  ]],
Cell[33993, 1081, 495, 14, 188, "Text"],
Cell[34491, 1097, 145, 5, 111, "Subsection",
  CellTags->"Trees"],
Cell[34639, 1104, 188, 5, 46, "Subsubsection"],

Cell[CellGroupData[{
Cell[34852, 1113, 481, 11, 156, "Input",
  CellTags->"Aurelianus"],
Cell[35336, 1126, 196, 3, 111, "Output",
  CellTags->"Aurelianus"]
}, Open  ]],
Cell[35547, 1132, 427, 9, 303, "LI",
  CellTags->"Index"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

